Loading...
Searching...
No Matches
XrdPosixExtern.hh File Reference
`#include <dirent.h>`
`#include <stdio.h>`
`#include <unistd.h>`
`#include <sys/types.h>`
`#include "XrdPosix/XrdPosixOsDep.hh"`
Include dependency graph for XrdPosixExtern.hh:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Functions

int | XrdPosix_Access (const char *path, int amode)
int | XrdPosix_Acl (const char *path, int cmd, int nentries, void *aclbufp)
int | XrdPosix_Chdir (const char *path)
int | XrdPosix_Close (int fildes)
int | XrdPosix_Closedir (DIR *dirp)
int | XrdPosix_Creat (const char *path, mode_t mode)
int | XrdPosix_Fclose (FILE *stream)
int | XrdPosix_Fcntl (int fd, int cmd,...)
int | XrdPosix_Fdatasync (int fildes)
int | XrdPosix_Fflush (FILE *stream)
FILE * | XrdPosix_Fopen (const char *path, const char *mode)
size_t | XrdPosix_Fread (void *ptr, size_t size, size_t nitems, FILE *stream)
int | XrdPosix_Fseek (FILE *stream, long offset, int whence)
int | XrdPosix_Fseeko (FILE *stream, off_t offset, int whence)
int | XrdPosix_Fstat (int fildes, struct stat *buf)
int | XrdPosix_Fsync (int fildes)
long | XrdPosix_Ftell (FILE *stream)
off_t | XrdPosix_Ftello (FILE *stream)
int | XrdPosix_Ftruncate (int fildes, off_t offset)
size_t | XrdPosix_Fwrite (const void *ptr, size_t size, size_t nitems, FILE *stream)
int | XrdPosix_isMyPath (const char *path)
off_t | XrdPosix_Lseek (int fildes, off_t offset, int whence)
int | XrdPosix_Lstat (const char *path, struct stat *buf)
int | XrdPosix_Mkdir (const char *path, mode_t mode)
int | XrdPosix_Open (const char *path, int oflag,...)
DIR * | XrdPosix_Opendir (const char *path)
long | XrdPosix_Pathconf (const char *path, int name)
ssize_t | XrdPosix_Pread (int fildes, void *buf, size_t nbyte, off_t offset)
ssize_t | XrdPosix_Pwrite (int fildes, const void *buf, size_t nbyte, off_t offset)
ssize_t | XrdPosix_Read (int fildes, void *buf, size_t nbyte)
struct dirent * | XrdPosix_Readdir (DIR *dirp)
struct dirent64 * | XrdPosix_Readdir64 (DIR *dirp)
int | XrdPosix_Readdir64_r (DIR *dirp, struct dirent64 *entry, struct dirent64 **result)
int | XrdPosix_Readdir_r (DIR *dirp, struct dirent *entry, struct dirent **result)
ssize_t | XrdPosix_Readv (int fildes, const struct iovec *iov, int iovcnt)
int | XrdPosix_Rename (const char *oname, const char *nname)
void | XrdPosix_Rewinddir (DIR *dirp)
int | XrdPosix_Rmdir (const char *path)
void | XrdPosix_Seekdir (DIR *dirp, long loc)
int | XrdPosix_Stat (const char *path, struct stat *buf)
int | XrdPosix_Statfs (const char *path, struct statfs *buf)
int | XrdPosix_Statvfs (const char *path, struct statvfs *buf)
long | XrdPosix_Telldir (DIR *dirp)
int | XrdPosix_Truncate (const char *path, off_t offset)
int | XrdPosix_Unlink (const char *path)
char * | XrdPosix_URL (const char *path, char *buff, int blen)
ssize_t | XrdPosix_Write (int fildes, const void *buf, size_t nbyte)
ssize_t | XrdPosix_Writev (int fildes, const struct iovec *iov, int iovcnt)

## Function Documentation

## XrdPosix_Access()

int XrdPosix_Access | ( | const char * | path,
|  | int | amode )

extern

Definition at line 114 of file XrdPosix.cc.

{
char *myPath, buff[2048];
// Make sure a path was passed
//
if (!path) {errno = EFAULT; return -1;}
// Return the results of a mkdir of a Unix file system
//
if (!(myPath = XrootPath.URL(path, buff, sizeof(buff))))
return Xunix.Access( path, amode);
// Return the results of our version of access()
//
return Xroot.Access(myPath, amode);
}
Xroot
XrdPosixXrootd Xroot
Definition XrdPosix.cc:50
XrootPath
XrdPosixXrootPath XrootPath
Definition XrdPosix.cc:52
Xunix
XrdPosixLinkage Xunix
Definition XrdPosixLinkage.cc:57

References Xroot, XrootPath, and Xunix.

Referenced by access().

Here is the caller graph for this function:

## XrdPosix_Acl()

int XrdPosix_Acl | ( | const char * | path,
|  | int | cmd,
|  | int | nentries,
|  | void * | aclbufp )

extern

Definition at line 141 of file XrdPosix.cc.

{
return (XrootPath.URL(path, 0, 0)
? Xunix.Acl("/tmp", cmd,nentries,aclbufp)
: Xunix.Acl(path, cmd,nentries,aclbufp));
}

References XrootPath, and Xunix.

Referenced by acl().

Here is the caller graph for this function:

## XrdPosix_Chdir()

int XrdPosix_Chdir | ( | const char * | path | ) |

extern

Definition at line 155 of file XrdPosix.cc.

{
int rc;
// Set the working directory if the actual chdir succeeded
//
if (!(rc = Xunix.Chdir(path))) XrootPath.CWD(path);
return rc;
}

References XrootPath, and Xunix.

Referenced by chdir().

Here is the caller graph for this function:

## XrdPosix_Close()

int XrdPosix_Close | ( | int | fildes | ) |

extern

Definition at line 172 of file XrdPosix.cc.

{
// Return result of the close
//
return (Xroot.myFD(fildes) ? Xroot.Close(fildes) : Xunix.Close(fildes));
}

References Xroot, and Xunix.

Referenced by close().

Here is the caller graph for this function:

## XrdPosix_Closedir()

int XrdPosix_Closedir | ( | DIR * | dirp | ) |

extern

Definition at line 187 of file XrdPosix.cc.

{
return (Xroot.isXrootdDir(dirp) ? Xroot.Closedir(dirp)
: Xunix.Closedir(dirp));
}

References Xroot, and Xunix.

Referenced by closedir().

Here is the caller graph for this function:

## XrdPosix_Creat()

int XrdPosix_Creat | ( | const char * | path,
|  | mode_t | mode )

extern

Definition at line 201 of file XrdPosix.cc.

{
extern int XrdPosix_Open(const char *path, int oflag, ...);
return XrdPosix_Open(path, O_WRONLY | O_CREAT | O_TRUNC, mode);
}
XrdPosix_Open
int XrdPosix_Open(const char *path, int oflag,...)
Definition XrdPosix.cc:639

References XrdPosix_Open().

Referenced by creat64().

Here is the call graph for this function:
Here is the caller graph for this function:

## XrdPosix_Fclose()

int XrdPosix_Fclose | ( | FILE * | stream | ) |

extern

Definition at line 215 of file XrdPosix.cc.

{
int nullfd = fileno(stream);
// Close the associated file
//
if (Xroot.myFD(nullfd)) Xroot.Close(nullfd);
// Now close the stream
//
return Xunix.Fclose(stream);
}

References Xroot, and Xunix.

Referenced by fclose().

Here is the caller graph for this function:

## XrdPosix_Fcntl()

int XrdPosix_Fcntl | ( | int | fd,
|  | int | cmd,
|  |  | ... )

extern

Definition at line 235 of file XrdPosix.cc.

{
va_list ap;
void *theArg;
if (Xroot.myFD(fd)) return 0;
va_start(ap, cmd);
theArg = va_arg(ap, void *);
va_end(ap);
return Xunix.Fcntl64(fd, cmd, theArg);
}

References Xroot, and Xunix.

Referenced by fcntl64().

Here is the caller graph for this function:

## XrdPosix_Fdatasync()

int XrdPosix_Fdatasync | ( | int | fildes | ) |

extern

Definition at line 254 of file XrdPosix.cc.

{
// Return the result of the sync
//
return (Xroot.myFD(fildes) ? Xroot.Fsync(fildes)
: Xunix.Fsync(fildes));
}

References Xroot, and Xunix.

Referenced by fdatasync().

Here is the caller graph for this function:

## XrdPosix_Fflush()

int XrdPosix_Fflush | ( | FILE * | stream | ) |

extern

Definition at line 285 of file XrdPosix.cc.

{
// Return the result of the fseek
//
if (!stream || !Xroot.myFD(fileno(stream)))
return Xunix.Fflush(stream);
return Xroot.Fsync(fileno(stream));
}

References Xroot, and Xunix.

Referenced by fflush().

Here is the caller graph for this function:

## XrdPosix_Fopen()

FILE * XrdPosix_Fopen | ( | const char * | path,
|  | const char * | mode )

extern

Definition at line 305 of file XrdPosix.cc.

{
char *myPath, buff[2048];
int erc, fd, omode;
FILE *stream;
// Transfer to unix if this is not our path
//
if (!(myPath = XrootPath.URL(path, buff, sizeof(buff))))
return Xunix.Fopen64(path, mode);
// Translate the mode flags
//
if (ISMODE("r") || ISMODE("rb")) omode = O_RDONLY;
else if (ISMODE("w") || ISMODE("wb")) omode = O_WRONLY
| O_CREAT | O_TRUNC;
else if (ISMODE("a") || ISMODE("ab")) omode = O_WRONLY
| O_CREAT | O_APPEND;
else if (ISMODE("r+") || ISMODE("rb+") || ISMODE("r+b")) omode = O_RDWR;
else if (ISMODE("w+") || ISMODE("wb+") || ISMODE("w+b")) omode = O_RDWR
| O_CREAT | O_TRUNC;
else if (ISMODE("a+") || ISMODE("ab+") || ISMODE("a+b")) omode = O_RDWR
| O_CREAT | O_APPEND;
else {errno = EINVAL; return 0;}
// Now open the file
//
if ((fd = Xroot.Open(myPath, omode | XrdPosixXrootd::isStream , 0)) < 0)
return 0;
// First obtain a free stream
//
if (!(stream = fdopen(fd, mode)))
{erc = errno; Xroot.Close(fd); errno = erc;}
// All done
//
return stream;
}
ISMODE
#define ISMODE(x)
Definition XrdPosix.cc:301
XrdPosixXrootd::isStream
static const int isStream
Definition XrdPosixXrootd.hh:166

References ISMODE, XrdPosixXrootd::isStream, Xroot, XrootPath, and Xunix.

Referenced by fopen64().

Here is the caller graph for this function:

## XrdPosix_Fread()

size_t XrdPosix_Fread | ( | void * | ptr,
|  | size_t | size,
|  | size_t | nitems,
|  | FILE * | stream )

extern

Definition at line 352 of file XrdPosix.cc.

{
ssize_t bytes;
size_t rc = 0;
int fd = fileno(stream);
if (!Xroot.myFD(fd)) return Xunix.Fread(ptr, size, nitems, stream);
bytes = Xroot.Read(fd, ptr, size*nitems);
// Get the right return code. Note that we cannot emulate the flags in sunx86
//
if (bytes > 0 && size) rc = bytes/size;
else if (bytes < 0) fseterr(stream);
else fseteof(stream);
return rc;
}
fseterr
static void fseterr(FILE *fp)
Definition XrdPosix.cc:64
fseteof
static void fseteof(FILE *fp)
Definition XrdPosix.cc:87

References fseteof(), fseterr(), Xroot, and Xunix.

Referenced by fread().

Here is the call graph for this function:
Here is the caller graph for this function:

## XrdPosix_Fseek()

int XrdPosix_Fseek | ( | FILE * | stream,
|  | long | offset,
|  | int | whence )

extern

Definition at line 378 of file XrdPosix.cc.

{
// Return the result of the fseek
//
if (!Xroot.myFD(fileno(stream)))
return Xunix.Fseek( stream, offset, whence);
return (Xroot.Lseek(fileno(stream), offset, whence) < 0 ? -1 : 0);
}

References Xroot, and Xunix.

Referenced by fseek().

Here is the caller graph for this function:

## XrdPosix_Fseeko()

int XrdPosix_Fseeko | ( | FILE * | stream,
|  | off_t | offset,
|  | int | whence )

extern

References stat.

## XrdPosix_Fstat()

int XrdPosix_Fstat | ( | int | fildes,
|  | struct stat * | buf )

extern

Definition at line 414 of file XrdPosix.cc.

{
// Return result of the close
//
return (Xroot.myFD(fildes)
? Xroot.Fstat(fildes, buf)
#if defined(__linux__) and defined(_STAT_VER)
: Xunix.Fstat64(_STAT_VER, fildes, (struct stat64 *)buf));
#else
: Xunix.Fstat64( fildes, (struct stat64 *)buf));
#endif
}
stat64
int stat64(const char *path, struct stat64 *buf)
Definition XrdPosixPreload.cc:687

References stat, stat64(), Xroot, and Xunix.

Referenced by fstat64().

Here is the call graph for this function:
Here is the caller graph for this function:

## XrdPosix_Fsync()

int XrdPosix_Fsync | ( | int | fildes | ) |

extern

Definition at line 448 of file XrdPosix.cc.

{
// Return the result of the sync
//
return (Xroot.myFD(fildes) ? Xroot.Fsync(fildes)
: Xunix.Fsync(fildes));
}

References Xroot, and Xunix.

Referenced by fsync().

Here is the caller graph for this function:

## XrdPosix_Ftell()

long XrdPosix_Ftell | ( | FILE * | stream | ) |

extern

Definition at line 464 of file XrdPosix.cc.

{
// Return the result of the tell
//
if (!Xroot.myFD(fileno(stream))) return Xunix.Ftell(stream);
return static_cast<long>(Xroot.Lseek(fileno(stream), 0, SEEK_CUR));
}

References Xroot, and Xunix.

Referenced by ftell().

Here is the caller graph for this function:

## XrdPosix_Ftello()

off_t XrdPosix_Ftello | ( | FILE * | stream | ) |

extern

Definition at line 481 of file XrdPosix.cc.

{
// Return the result of the tell
//
if (!Xroot.myFD(fileno(stream))) return Xunix.Ftello64(stream);
return Xroot.Lseek(fileno(stream), 0, SEEK_CUR);
}

References Xroot, and Xunix.

Referenced by ftello64().

Here is the caller graph for this function:

## XrdPosix_Ftruncate()

int XrdPosix_Ftruncate | ( | int | fildes,
|  | off_t | offset )

extern

References stat, statfs, and statvfs.

## XrdPosix_Fwrite()

size_t XrdPosix_Fwrite | ( | const void * | ptr,
|  | size_t | size,
|  | size_t | nitems,
|  | FILE * | stream )

extern

Definition at line 514 of file XrdPosix.cc.

{
size_t bytes, rc = 0;
int fd = fileno(stream);
if (!Xroot.myFD(fd)) return Xunix.Fwrite(ptr, size, nitems, stream);
bytes = Xroot.Write(fd, ptr, size*nitems);
// Get the right return code.
//
if (bytes > 0 && size) rc = bytes/size;
else fseterr(stream);
return rc;
}

References fseterr(), Xroot, and Xunix.

Referenced by fwrite().

Here is the call graph for this function:
Here is the caller graph for this function:

## XrdPosix_isMyPath()

int XrdPosix_isMyPath | ( | const char * | path | ) |

extern

Definition at line 1080 of file XrdPosix.cc.

{
return (0 != XrootPath.URL(path, 0, 0));
}

References XrootPath.

## XrdPosix_Lseek()

off_t XrdPosix_Lseek | ( | int | fildes,
|  | off_t | offset,
|  | int | whence )

extern

Definition at line 572 of file XrdPosix.cc.

{
// Return the operation of the seek
//
return (Xroot.myFD(fildes) ? Xroot.Lseek (fildes, offset, whence)
: Xunix.Lseek64(fildes, offset, whence));
}

References Xroot, and Xunix.

Referenced by llseek(), and lseek64().

Here is the caller graph for this function:

## XrdPosix_Lstat()

int XrdPosix_Lstat | ( | const char * | path,
|  | struct stat * | buf )

extern

Definition at line 588 of file XrdPosix.cc.

{
char *myPath, buff[2048];
// Make sure a path was passed
//
if (!path) {errno = EFAULT; return -1;}
// Return the results of an open of a Unix file
//
return (!(myPath = XrootPath.URL(path, buff, sizeof(buff)))
#if defined(__linux__) and defined(_STAT_VER)
? Xunix.Lstat64(_STAT_VER, path, (struct stat64 *)buf)
#else
? Xunix.Lstat64( path, (struct stat64 *)buf)
#endif
: Xroot.Stat(myPath, buf));
}

References stat, stat64(), Xroot, XrootPath, and Xunix.

Referenced by lstat64().

Here is the call graph for this function:
Here is the caller graph for this function:

## XrdPosix_Mkdir()

int XrdPosix_Mkdir | ( | const char * | path,
|  | mode_t | mode )

extern

Definition at line 614 of file XrdPosix.cc.

{
char *myPath, buff[2048];
// Make sure a path was passed
//
if (!path) {errno = EFAULT; return -1;}
// Return the results of a mkdir of a Unix file system
//
if (!(myPath = XrootPath.URL(path, buff, sizeof(buff))))
return Xunix.Mkdir(path, mode);
// Return the results of an mkdir of an xrootd file system
//
return Xroot.Mkdir(myPath, mode);
}

References Xroot, XrootPath, and Xunix.

Referenced by mkdir().

Here is the caller graph for this function:

## XrdPosix_Open()

int XrdPosix_Open | ( | const char * | path,
|  | int | oflag,
|  |  | ... )

extern

Definition at line 639 of file XrdPosix.cc.

{
char *myPath, buff[2048];
va_list ap;
int mode;
// Make sure a path was passed
//
if (!path) {errno = EFAULT; return -1;}
// Return the results of an open of a Unix file
//
if (!(myPath = XrootPath.URL(path, buff, sizeof(buff))))
{if (!(oflag & O_CREAT)) return Xunix.Open64(path, oflag);
va_start(ap, oflag);
mode = va_arg(ap, int);
va_end(ap);
return Xunix.Open64(path, oflag, (mode_t)mode);
}
// Return the results of an open of an xrootd file
//
if (!(oflag & O_CREAT)) return Xroot.Open(myPath, oflag);
va_start(ap, oflag);
mode = va_arg(ap, int);
va_end(ap);
return Xroot.Open(myPath, oflag, (mode_t)mode);
}

References Xroot, XrootPath, and Xunix.

Referenced by open64(), and XrdPosix_Creat().

Here is the caller graph for this function:

## XrdPosix_Opendir()

DIR * XrdPosix_Opendir | ( | const char * | path | ) |

extern

Definition at line 675 of file XrdPosix.cc.

{
char *myPath, buff[2048];
// Make sure a path was passed
//
if (!path) {errno = EFAULT; return 0;}
// Unix opendir
//
if (!(myPath = XrootPath.URL(path, buff, sizeof(buff))))
return Xunix.Opendir(path);
// Xrootd opendir
//
return Xroot.Opendir(myPath);
}

References Xroot, XrootPath, and Xunix.

Referenced by opendir().

Here is the caller graph for this function:

## XrdPosix_Pathconf()

long XrdPosix_Pathconf | ( | const char * | path,
|  | int | name )

extern

Definition at line 702 of file XrdPosix.cc.

{
return (XrootPath.URL(path, 0, 0) ? Xunix.Pathconf("/tmp", name)
: Xunix.Pathconf(path, name));
}

References XrootPath, and Xunix.

Referenced by pathconf().

Here is the caller graph for this function:

## XrdPosix_Pread()

ssize_t XrdPosix_Pread | ( | int | fildes,
|  | void * | buf,
|  | size_t | nbyte,
|  | off_t | offset )

extern

Definition at line 715 of file XrdPosix.cc.

{
// Return the results of the read
//
return (Xroot.myFD(fildes) ? Xroot.Pread (fildes, buf, nbyte, offset)
: Xunix.Pread64(fildes, buf, nbyte, offset));
}

References Xroot, and Xunix.

Referenced by pread64().

Here is the caller graph for this function:

## XrdPosix_Pwrite()

ssize_t XrdPosix_Pwrite | ( | int | fildes,
|  | const void * | buf,
|  | size_t | nbyte,
|  | off_t | offset )

extern

Definition at line 731 of file XrdPosix.cc.

{
// Return the results of the write
//
return (Xroot.myFD(fildes) ? Xroot.Pwrite (fildes, buf, nbyte, offset)
: Xunix.Pwrite64(fildes, buf, nbyte, offset));
}

References Xroot, and Xunix.

Referenced by pwrite64().

Here is the caller graph for this function:

## XrdPosix_Read()

ssize_t XrdPosix_Read | ( | int | fildes,
|  | void * | buf,
|  | size_t | nbyte )

extern

Definition at line 747 of file XrdPosix.cc.

{
// Return the results of the read
//
return (Xroot.myFD(fildes) ? Xroot.Read(fildes, buf, nbyte)
: Xunix.Read(fildes, buf, nbyte));
}

References Xroot, and Xunix.

Referenced by read().

Here is the caller graph for this function:

## XrdPosix_Readdir()

struct dirent * XrdPosix_Readdir | ( | DIR * | dirp | ) |

extern

Definition at line 781 of file XrdPosix.cc.

{
// Return result of readdir
//
return (Xroot.isXrootdDir(dirp) ? Xroot.Readdir(dirp)
: Xunix.Readdir(dirp));
}

References Xroot, and Xunix.

## XrdPosix_Readdir64()

struct dirent64 * XrdPosix_Readdir64 | ( | DIR * | dirp | ) |

extern

Definition at line 790 of file XrdPosix.cc.

{
// Return result of readdir
//
return (Xroot.isXrootdDir(dirp) ? Xroot.Readdir64(dirp)
: Xunix.Readdir64(dirp));
}

References Xroot, and Xunix.

Referenced by readdir64().

Here is the caller graph for this function:

## XrdPosix_Readdir64_r()

int XrdPosix_Readdir64_r | ( | DIR * | dirp,
|  | struct dirent64 * | entry,
|  | struct dirent64 ** | result )

extern

Definition at line 815 of file XrdPosix.cc.

{
// Return result of readdir
//
return (Xroot.isXrootdDir(dirp) ? Xroot.Readdir64_r(dirp,entry,result)
: Xunix.Readdir64_r(dirp,entry,result));
}

References Xroot, and Xunix.

Referenced by readdir64_r().

Here is the caller graph for this function:

## XrdPosix_Readdir_r()

int XrdPosix_Readdir_r | ( | DIR * | dirp,
|  | struct dirent * | entry,
|  | struct dirent ** | result )

extern

Definition at line 806 of file XrdPosix.cc.

{
// Return result of readdir
//
return (Xroot.isXrootdDir(dirp) ? Xroot.Readdir_r(dirp,entry,result)
: Xunix.Readdir_r(dirp,entry,result));
}

References Xroot, and Xunix.

## XrdPosix_Readv()

ssize_t XrdPosix_Readv | ( | int | fildes,
|  | const struct iovec * | iov,
|  | int | iovcnt )

extern

Definition at line 763 of file XrdPosix.cc.

{
// Return results of the readv
//
return (Xroot.myFD(fildes) ? Xroot.Readv(fildes, iov, iovcnt)
: Xunix.Readv(fildes, iov, iovcnt));
}
iov
Definition XrdOucIOVec.hh:65

References Xroot, and Xunix.

Referenced by readv().

Here is the caller graph for this function:

## XrdPosix_Rename()

int XrdPosix_Rename | ( | const char * | oname,
|  | const char * | nname )

extern

Definition at line 831 of file XrdPosix.cc.

{
char *oldPath, buffold[2048], *newPath, buffnew[2048];
// Make sure a path was passed
//
if (!oldpath || !newpath) {errno = EFAULT; return -1;}
// Return the results of a mkdir of a Unix file system
//
if (!(oldPath = XrootPath.URL(oldpath, buffold, sizeof(buffold)))
|| !(newPath = XrootPath.URL(newpath, buffnew, sizeof(buffnew))))
return Xunix.Rename(oldpath, newpath);
// Return the results of an mkdir of an xrootd file system
//
return Xroot.Rename(oldPath, newPath);
}

References Xroot, XrootPath, and Xunix.

Referenced by rename().

Here is the caller graph for this function:

## XrdPosix_Rewinddir()

void XrdPosix_Rewinddir | ( | DIR * | dirp | ) |

extern

Definition at line 857 of file XrdPosix.cc.

{
// Return result of rewind
//
return (Xroot.isXrootdDir(dirp) ? Xroot.Rewinddir(dirp)
: Xunix.Rewinddir(dirp));
}

References Xroot, and Xunix.

Referenced by rewinddir().

Here is the caller graph for this function:

## XrdPosix_Rmdir()

int XrdPosix_Rmdir | ( | const char * | path | ) |

extern

Definition at line 873 of file XrdPosix.cc.

{
char *myPath, buff[2048];
// Make sure a path was passed
//
if (!path) {errno = EFAULT; return -1;}
// Return the results of a mkdir of a Unix file system
//
if (!(myPath = XrootPath.URL(path, buff, sizeof(buff))))
return Xunix.Rmdir(path);
// Return the results of an mkdir of an xrootd file system
//
return Xroot.Rmdir(myPath);
}

References Xroot, XrootPath, and Xunix.

Referenced by rmdir().

Here is the caller graph for this function:

## XrdPosix_Seekdir()

void XrdPosix_Seekdir | ( | DIR * | dirp,
|  | long | loc )

extern

Definition at line 898 of file XrdPosix.cc.

{
// Call seekdir
//
(Xroot.isXrootdDir(dirp) ? Xroot.Seekdir(dirp, loc)
: Xunix.Seekdir(dirp, loc));
}

References Xroot, and Xunix.

Referenced by seekdir().

Here is the caller graph for this function:

## XrdPosix_Stat()

int XrdPosix_Stat | ( | const char * | path,
|  | struct stat * | buf )

extern

Definition at line 914 of file XrdPosix.cc.

{
char *myPath, buff[2048];
// Make sure a path was passed
//
if (!path) {errno = EFAULT; return -1;}
// Return the results of an open of a Unix file
//
return (!(myPath = XrootPath.URL(path, buff, sizeof(buff)))
#if defined(__linux__) and defined(_STAT_VER)
? Xunix.Stat64(_STAT_VER, path, (struct stat64 *)buf)
#else
? Xunix.Stat64( path, (struct stat64 *)buf)
#endif
: Xroot.Stat(myPath, buf));
}

References stat, stat64(), Xroot, XrootPath, and Xunix.

Referenced by stat64().

Here is the call graph for this function:
Here is the caller graph for this function:

## XrdPosix_Statfs()

int XrdPosix_Statfs | ( | const char * | path,
|  | struct statfs * | buf )

extern

Definition at line 940 of file XrdPosix.cc.

{
char *myPath, buff[2048];
// Make sure a path was passed
//
if (!path) {errno = EFAULT; return -1;}
// Return the results of an open of a Unix file
//
return ((myPath = XrootPath.URL(path, buff, sizeof(buff)))
? Xroot.Statfs(myPath, buf)
: Xunix.Statfs64(path, (struct statfs64 *)buf));
}
statfs64
int statfs64(const char *path, struct statfs64 *buf)
Definition XrdPosixPreload.cc:703

References statfs, statfs64(), Xroot, XrootPath, and Xunix.

Referenced by statfs64().

Here is the call graph for this function:
Here is the caller graph for this function:

## XrdPosix_Statvfs()

int XrdPosix_Statvfs | ( | const char * | path,
|  | struct statvfs * | buf )

extern

Definition at line 962 of file XrdPosix.cc.

{
char *myPath, buff[2048];
// Make sure a path was passed
//
if (!path) {errno = EFAULT; return -1;}
// Return the results of an open of a Unix file
//
return ((myPath = XrootPath.URL(path, buff, sizeof(buff)))
? Xroot.Statvfs(myPath, buf)
: Xunix.Statvfs64(path, (struct statvfs64 *)buf));
}
statvfs64
int statvfs64(const char *path, struct statvfs64 *buf)
Definition XrdPosixPreload.cc:718

References statvfs, statvfs64(), Xroot, XrootPath, and Xunix.

Referenced by statvfs64().

Here is the call graph for this function:
Here is the caller graph for this function:

## XrdPosix_Telldir()

long XrdPosix_Telldir | ( | DIR * | dirp | ) |

extern

Definition at line 984 of file XrdPosix.cc.

{
// Return result of telldir
//
return (Xroot.isXrootdDir(dirp) ? Xroot.Telldir(dirp)
: Xunix.Telldir(dirp));
}

References Xroot, and Xunix.

Referenced by telldir().

Here is the caller graph for this function:

## XrdPosix_Truncate()

int XrdPosix_Truncate | ( | const char * | path,
|  | off_t | offset )

extern

Definition at line 1000 of file XrdPosix.cc.

{
char *myPath, buff[2048];
// Make sure a path was passed
//
if (!path) {errno = EFAULT; return -1;}
// Return the results of a truncate of a Unix file system
//
if (!(myPath = XrootPath.URL(path, buff, sizeof(buff))))
return Xunix.Truncate64(path, offset);
// Return the results of an truncate of an xrootd file system
//
return Xroot.Truncate(myPath, offset);
}

References Xroot, XrootPath, and Xunix.

Referenced by truncate64().

Here is the caller graph for this function:

## XrdPosix_Unlink()

int XrdPosix_Unlink | ( | const char * | path | ) |

extern

Definition at line 1025 of file XrdPosix.cc.

{
char *myPath, buff[2048];
// Make sure a path was passed
//
if (!path) {errno = EFAULT; return -1;}
// Return the result of a unlink of a Unix file
//
if (!(myPath = XrootPath.URL(path, buff, sizeof(buff))))
return Xunix.Unlink(path);
// Return the results of an unlink of an xrootd file
//
return Xroot.Unlink(myPath);
}

References Xroot, XrootPath, and Xunix.

Referenced by unlink().

Here is the caller graph for this function:

## XrdPosix_URL()

char * XrdPosix_URL | ( | const char * | path,
|  | char * | buff,
|  | int | blen )

extern

Definition at line 1089 of file XrdPosix.cc.

{
return XrootPath.URL(path, buff, blen);
}

References XrootPath.

## XrdPosix_Write()

ssize_t XrdPosix_Write | ( | int | fildes,
|  | const void * | buf,
|  | size_t | nbyte )

extern

Definition at line 1050 of file XrdPosix.cc.

{
// Return the results of the write
//
return (Xroot.myFD(fildes) ? Xroot.Write(fildes, buf, nbyte)
: Xunix.Write(fildes, buf, nbyte));
}

References Xroot, and Xunix.

Referenced by write().

Here is the caller graph for this function:

## XrdPosix_Writev()

ssize_t XrdPosix_Writev | ( | int | fildes,
|  | const struct iovec * | iov,
|  | int | iovcnt )

extern

Definition at line 1066 of file XrdPosix.cc.

{
// Return results of the writev
//
return (Xroot.myFD(fildes) ? Xroot.Writev(fildes, iov, iovcnt)
: Xunix.Writev(fildes, iov, iovcnt));
}

References Xroot, and Xunix.

Referenced by writev().

Here is the caller graph for this function: